module Quietus
  class ActiveServer
    attr_reader :instance_id, :respect_grace_period, :status

    def initialize(auto_scaling_instance, respect_grace_period = true)
      @respect_grace_period  = respect_grace_period
      @auto_scaling_instance = auto_scaling_instance

      server &Proc.new
    end

    private

    def server(&proc)
      loop do
        new_status = proc.call
        if (new_status != status) && ENV['APP_ENV'] == 'production'
          update new_status
        end
      end
    end

    def update(status)
      @auto_scaling_instance.set_health(
        status ? 'Healthy' : 'Unhealthy',
        :should_respect_grace_period => respect_grace_period
      )
    end
  end
end

