require "socket"

module Quietus
  class PassiveServer
    attr_reader :port, :hostname

    DEFAULT_HOSTNAME = 'localhost'
    DEFAULT_PORT     = 2347

    def initialize(hostname = nil, port = nil)
      @hostname   = hostname || DEFAULT_HOSTNAME
      @port       = port     || DEFAULT_PORT

      server &Proc.new
    end

    private

    def server(&proc)
      loop { respond if proc.call }
    end

    def respond
      TCPServer.open(hostname, port) { |s| s.accept.close }
    end
  end
end

